# Copyright 2011 Tommy Poulter
#
# This file is part of basechip.
#
# basechip is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
# 
# basechip is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with basechip.  If not, see <http://www.gnu.org/licenses/>.

tool :icarus do |t|
  t.default_version "0.9.4"

  t.packages :ubuntu => %w{ build-essential
                            git-core
                            wget 
                          }
  vs = %w{0.4 0.6 0.6.1 0.7 0.8 0.8.1 0.8.2 0.8.3 0.8.4 0.8.5 0.8.6 0.8.7 0.9.1 0.9.2 0.9.3 0.9.4 cvshead elaborate-net-rework embedded-vvp master pei-branch performance v0_6-branch v0_8-branch v0_8-devel v0_9-branch var-array-rework verilog-ams version0_1 vvp-net-out-rework}
  vs.each do |name|
    t.version name do |v|
      v.install %{
        mkdir -p                                         #{v.path}     &&
        git clone git://icarus.com/~steve-icarus/verilog #{v.tool.path}/tmp &&
        cd                                               #{v.tool.path}/tmp &&
        #{
          case v.name
          when /^[\d\.]+$/; "git checkout v#{v.name.gsub(/\./,'_')} &&\n"
          when 'master'   ;
          else            ; "git checkout #{ v.name               } &&\n"
          end
}        sh autoconf.sh &&
        ./configure --prefix=#{v.path} &&
        make         &&
        make install &&
        rm -rf               #{v.tool.path}/tmp
      }
    end
  end
end

action :icarus do |a|
  a.log_to   "icarus.log"
  a.out_file "icarus.log" do end

  a.before lambda {
    f = File.open("icarus.f","w")
    f.puts((a.configuration.bom.headers.to_a.map{|h| "+incdir+#{h}"} + 
            a.configuration.bom.verilog.to_a                         ).join("\n"))
    f.close
  }

  a.configuration.tools[:icarus].configure
  a.command "#{a.configuration.tools[:icarus].path}/bin/iverilog #{a.args} -f icarus.f"
end

action :icarun do |a|
  a.log_to   "icarun.log"
  a.out_file "icarun.log" do end

  a.append_depends [:icarus]

  a.args BaseChip.options.replace_arguments.join(' ') if BaseChip.options.replace_arguments

  a.configuration.actions[:icarus].configure
  a.command "#{a.configuration.actions[:icarus].directory}/a.out #{BaseChip.options.append_arguments.join(' ') if BaseChip.options.append_arguments} #{a.args}"
end

