# Copyright 2011 Tommy Poulter
#
# This file is part of basechip.
#
# basechip is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
# 
# basechip is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with basechip.  If not, see <http://www.gnu.org/licenses/>.

module BaseChip
  class BomType
    def initialize(bom,type)
      @bom    = bom
      @type   = type
    end
    def to_s
      "#{@bom.name1}.#{@bom.name2}.#{@type}"
    end
    def make
      f = File.open(to_s,'w')
      case @type
      when :text ; f.puts @bom.to_a.join("\n")
      when :tcl  ; fault "TCL formatted bom files not yet implemented"
      else       ; fault "#{@type.inspect} was not understood by #{self.class}"
      end
      f.close
    end
  end

  class Bom
    def text
      @text ||= BomType.new(self,:text)
    end
    def tcl
      @tcl  ||= BomType.new(self,:tcl )
    end
  end
end
