# Copyright 2011 Tommy Poulter
#
# This file is part of basechip.
#
# basechip is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
# 
# basechip is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with basechip.  If not, see <http://www.gnu.org/licenses/>.

require 'base_chip/cluster'

module BaseChip
  class ClusterType
    include Dsl
    include Base

    define_children({:cluster => Cluster})

    def dereference(name,jobs,passive)
      configure
      clusters = []
      unless @clusters
        fault "No clusters are specified for the cluster type '#{@name}'" unless passive
        return clusters
      end

      if name == 'all' || name == ''
        clusters = @clusters.values
      elsif cluster = @clusters[name.to_s]
        clusters << cluster
      else
        fault "No clusters could be found named '#{name}' of type '#{@name}'" unless passive
      end

      clusters
    end
  end
end
