# Copyright 2011 Tommy Poulter
#
# This file is part of basechip.
#
# basechip is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
# 
# basechip is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with basechip.  If not, see <http://www.gnu.org/licenses/>.

module BaseChip
  class Git
    def initialize(root)
      @root = root
    end
    def changed
      files = `cd #{@root} && git status`.split(/\n/)
      files.delete_if do |f|
        f !~ /#\t/
      end
      files.map! do |f|
        f.gsub(/#\s+(modified|new file):\s+/,'')
      end
    end
  end
end
