# Copyright 2011 Tommy Poulter
#
# This file is part of basechip.
#
# basechip is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
# 
# basechip is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with basechip.  If not, see <http://www.gnu.org/licenses/>.

require 'drb'

# require 'zmq'
# require 'ffi'
Thread.abort_on_exception = true

module BaseChip
  module Ipc
    def self.included mod
      mod.extend Ipc::ClassMethods
      mod.class_eval do
        include Ipc::InstanceMethods
      end
    end
    module ClassMethods
      # class instance variables
    end
    module InstanceMethods
      def init_test_sockets(type = :client) # or :server
        DRb.start_service nil, self
        if @client_of
          @server = DRbObject.new nil, @client_of
          @server.register_client(DRb.uri)
        else
          @clients_ready = []
          @clients_all   = []
        end
      end
      def register_client(address)
        @clients_all << DRbObject.new(nil, address)
      end
    end
  end
end
