# Copyright 2011 Tommy Poulter
#
# This file is part of basechip.
#
# basechip is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
# 
# basechip is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with basechip.  If not, see <http://www.gnu.org/licenses/>.

require 'thor'
require 'reporting'
module BaseChip
  class Menu # < Thor
    include Reporting
    def smart_print(string, object, *array)
      if @pattern == nil
        list_line(string,object)
        return
      end
      if @pattern.is_a? Regexp
        if string.is_a? Array
          array += string
        else
          array << string
        end
        array.each do |str|
          if str =~ @pattern
            list_line(string,object)
            return
          end
        end
      else
        if array.include? @pattern
          list_line(string,object)
          return
        end
        if string == @pattern
          list_line(string,object)
          return
        end
      end
    end
    def list_line(string,object)
      array = (string.is_a? Array) ? string : [string]

      if self.options.show
        object.configure
        tmp = object
        self.options.show.split(/\./).each do |fun|
          fault("Object of type #{tmp.respond_to?(:class_string) ? tmp.class_string : tmp.class} does not have a data element #{fun.inspect}") unless tmp.respond_to?(fun)
          tmp = tmp.send(fun)
        end
        array << tmp
      end

      if array.size == 1
        puts string
      else
        @table << array
      end
    end
  end
end
