# Copyright 2011 Tommy Poulter
#
# This file is part of basechip.
#
# basechip is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
# 
# basechip is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with basechip.  If not, see <http://www.gnu.org/licenses/>.

require 'base_chip/track_state'
require 'base_chip/taskable'

module BaseChip
  module Runable
    def self.included mod
      mod.extend Runable::ClassMethods
      mod.class_eval do
        include Runable::InstanceMethods
        include Taskable
        include TrackState
        attr_accessor :cl_args
      end
    end
    module ClassMethods
    end
    module InstanceMethods
    end
  end
end
