# Copyright 2011 Tommy Poulter
#
# This file is part of basechip.
#
# basechip is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
# 
# basechip is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with basechip.  If not, see <http://www.gnu.org/licenses/>.

module BaseChip
  class SourceLanguage
    include Dsl
    include Base
    define_settings({:directories      => [ Array       ],
                     :globs            => [ Array       ],
                     :files            => [ Array       ]})

    def configure
      return if @configured
      super
      if @globs and @directories and not @files
        @files = []
        @globs.each do |e|
          @directories.each do |d|
            d = absolute_path d
            @files += Dir.glob("#{d}/#{e}")
          end
        end
        # @files.uniq!
      end
    end
  end
end
