# Copyright 2011 Tommy Poulter
#
# This file is part of basechip.
#
# basechip is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
# 
# basechip is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with basechip.  If not, see <http://www.gnu.org/licenses/>.

require 'yaml'
# require 'ipc'
YAML::ENGINE.yamler = 'psych'

module BaseChip
  module TaskMaster
    TASKER = Tasker
    def self.included mod
      mod.extend TaskMaster::ClassMethods
      mod.class_eval do
        include TaskMaster::InstanceMethods
        attr_accessor :tasker
      end
    end
    module ClassMethods
    end
    module InstanceMethods
      def initialize(*args)
        super(*args)
        @tasker = TASKER.new
        @tasker.task_master = self
      end
      def tasker_run_task
        raise "Please extend tasker_run_task routine"
      end
      def tasker_handle_results(action, result)
        raise "Please extend tasker_handle_results routine"
      end
      def tasker_empty
        raise "Please extend tasker_run_task routine"
      end
    end
  end
end
