# Copyright 2011 Tommy Poulter
#
# This file is part of basechip.
#
# basechip is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
# 
# basechip is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with basechip.  If not, see <http://www.gnu.org/licenses/>.

class Dir
  @@pushd_stack = []
  def self.pushd(d)
    @@pushd_stack << Dir.pwd
    Dir.chdir d
  end
  def self.popd
    if d = @@pushd_stack.pop
      Dir.chdir d
    else
      raise "directory stack empty, pwd = #{Dir.pwd}"
    end
  end
end
